/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2011-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Os.h 492 2014-09-29 05:35:11Z t_ishikawa $
 */

/*
 *		ATK2 OSإåե
 *
 *  ATK2ݡȤ륷ƥॵӥȡɬפʥǡ
 *  ޥޤإåե
 *
 *  ֥Υե뤫餳Υե򥤥󥯥롼ɤ
 *  ϡTOPPERS_MACRO_ONLYƤ
 *  ˤꡤޥʳ褦ˤʤäƤ
 *
 *  Υե򥤥󥯥롼ɤ˥󥯥롼ɤƤ٤ե
 *  Ϥʤ
 */

#ifndef TOPPERS_OS_H
#define TOPPERS_OS_H

/*
 *  ̤Υǡޥ
 */
#include "Std_Types.h"
#include "MemMap.h"
#include "Rte_Os_Type.h"

#if !defined(TOPPERS_CFG1_OUT) && !defined(OMIT_INCLUDE_OS_CFG)
#include "Os_Cfg.h"
#endif

/*
 *  åȰ¸
 */
#include "target_kernel.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ǡ
 */

/*
 *  ֹ֥η
 */
typedef uint8	TaskStateType;              /*  */
typedef uint32	EventMaskType;              /* ٥ȥޥ */
typedef uint32	TickType;                   /* ͡ʥƥå*/
typedef uint32	AppModeType;                /* ץꥱ⡼ */
typedef uint8	OSServiceIdType;            /* ƥॵӥID */
typedef uint8	ScheduleTableStatusType;    /* 塼ơ֥ */
typedef uint8	ProtectionReturnType;       /* ץƥեå֤ */
typedef uintptr	MemorySizeType;             /* ΰ襵 */

typedef struct {
	TickType	maxallowedvalue;            /* 󥿻κ */
	TickType	ticksperbase;               /* OSǤϻѤ桼ͳ˻Ѥ */
	TickType	mincycle;                   /* κǾ */
} AlarmBaseType;

/*
 *  Ŭ뤿ᡤ¸Ǥ뷿
 */
#ifndef OMIT_DATA_TYPE
typedef uint32	TimeType;                   /*  */
typedef uint32	AlarmType;                  /* 顼ID */
typedef uint32	ResourceType;               /* ꥽ID */
typedef uint32	TaskType;                   /* ID */
typedef uint32	ISRType;                    /* ISR ID */
typedef uint32	CounterType;                /* ID */
typedef uint32	ScheduleTableType;          /* 塼ơ֥ID */
typedef float32	PhysicalTimeType;           /* ʥƥå֤˴ѡ˻ */
#endif /* OMIT_DATA_TYPE */

typedef AlarmBaseType *				AlarmBaseRefType;
typedef TaskType *					TaskRefType;
typedef TaskStateType *				TaskStateRefType;
typedef EventMaskType *				EventMaskRefType;
typedef TickType *					TickRefType;
typedef ScheduleTableStatusType *	ScheduleTableStatusRefType;

/*
 *  ݸȿ򵯤ñ̤η
 */
typedef uint8 FaultyContextType;

/*
 *  OS֥ѤΥޥ
 */
#define DeclareTask(TaskIdentifier)
#define DeclareResource(ResourceIdentifier)
#define DeclareEvent(EventIdentifier)
#define DeclareAlarm(AlarmIdentifier)

/*
 *  ᥤ롼ѤΥޥ
 */
#define TASK(TaskName)		void TaskMain ## TaskName(void)
#define ISR(ISRName)		void ISRMain ## ISRName(void)
#ifndef C1ISR
#define C1ISR(ISRName)		void C1ISRMain ## ISRName(void)
#endif /* C1ISR */
#define ALARMCALLBACK(AlarmCallBackName) \
	void AlarmMain ## AlarmCallBackName(void)

/*
 *  ΰݤΤη
 */
#ifndef TOPPERS_STK_T
#define TOPPERS_STK_T	sintptr
#endif /* TOPPERS_STK_T */
typedef	TOPPERS_STK_T StackType;    /* åΰݤ뤿η */

/*
 *  ƥॵӥѥ᡼Τ
 */
typedef union {
	TaskType					tskid;
	TaskRefType					p_tskid;
	TaskStateRefType			p_stat;
	ResourceType				resid;
	EventMaskType				mask;
	EventMaskRefType			p_mask;
	AlarmType					almid;
	AlarmBaseRefType			p_info;
	TickRefType					p_tick;
	TickRefType					p_val;
	TickRefType					p_eval;
	TickType					incr;
	TickType					cycle;
	TickType					start;
	AppModeType					mode;
	CounterType					cntid;
	ScheduleTableType			schtblid;
	TickType					offset;
	ScheduleTableType			schtblid_from;
	ScheduleTableType			schtblid_to;
	ScheduleTableStatusRefType	p_schtblstate;
} _ErrorHook_Par;

/*
 *  ΰݤΤΥޥ
 *
 *  ʲTOPPERS_COUNT_SZTOPPERS_ROUND_SZϡunit2ζҾǤ
 *  뤳ȤꤷƤ롥
 */
#ifndef TOPPERS_COUNT_SZ
#define TOPPERS_COUNT_SZ(sz, unit)	(((sz) + (unit) - (1U)) / (unit))
#endif /* TOPPERS_COUNT_SZ */
#ifndef TOPPERS_ROUND_SZ
#define TOPPERS_ROUND_SZ(sz, unit)	(((sz) + (unit) - (1U)) & (~((unit) - (1U))))
#endif /* TOPPERS_ROUND_SZ */

#define COUNT_STK_T(sz)		(TOPPERS_COUNT_SZ((sz), sizeof(StackType)))
#define ROUND_STK_T(sz)		(TOPPERS_ROUND_SZ((sz), sizeof(StackType)))

/*
 *  ƥॵӥAPI
 */

/*
 *  OS
 */
extern AppModeType GetActiveApplicationMode(void);
extern void StartOS(AppModeType Mode);
extern void ShutdownOS(StatusType Error);
extern FaultyContextType GetFaultyContext(void);

/*
 *  
 */
extern StatusType ActivateTask(TaskType TaskID);
extern StatusType TerminateTask(void);
extern StatusType ChainTask(TaskType TaskID);
extern StatusType Schedule(void);
extern StatusType GetTaskID(TaskRefType TaskID);
extern StatusType GetTaskState(TaskType TaskID, TaskStateRefType State);

/*
 *  ߴ
 */
extern void EnableAllInterrupts(void);
extern void DisableAllInterrupts(void);
extern void ResumeAllInterrupts(void);
extern void SuspendAllInterrupts(void);
extern void ResumeOSInterrupts(void);
extern void SuspendOSInterrupts(void);
extern ISRType GetISRID(void);

/*
 *  ٥ȴ
 */
extern StatusType SetEvent(TaskType TaskID, EventMaskType Mask);
extern StatusType ClearEvent(EventMaskType Mask);
extern StatusType GetEvent(TaskType TaskID, EventMaskRefType Event);
extern StatusType WaitEvent(EventMaskType Mask);

/*
 *  ꥽
 */
extern StatusType GetResource(ResourceType ResID);
extern StatusType ReleaseResource(ResourceType ResID);

/*
 *  
 */
extern StatusType IncrementCounter(CounterType CounterID);

/*
 *  եȥե꡼󥿥
 */
extern StatusType GetCounterValue(CounterType CounterID, TickRefType Value);
extern StatusType GetElapsedValue(CounterType CounterID, TickRefType Value, TickRefType ElapsedValue);

/*
 *  顼
 */
extern StatusType GetAlarmBase(AlarmType AlarmID, AlarmBaseRefType Info);
extern StatusType GetAlarm(AlarmType AlarmID, TickRefType Tick);
extern StatusType SetRelAlarm(AlarmType AlarmID, TickType increment, TickType cycle);
extern StatusType SetAbsAlarm(AlarmType AlarmID, TickType start, TickType cycle);
extern StatusType CancelAlarm(AlarmType AlarmID);

/*
 *  塼ơ֥
 */
extern StatusType StartScheduleTableRel(ScheduleTableType ScheduleTableID, TickType Offset);
extern StatusType StartScheduleTableAbs(ScheduleTableType ScheduleTableID, TickType Start);
extern StatusType StopScheduleTable(ScheduleTableType ScheduleTableID);
extern StatusType NextScheduleTable(ScheduleTableType ScheduleTableID_From, ScheduleTableType ScheduleTableID_To);
extern StatusType GetScheduleTableStatus(ScheduleTableType ScheduleTableID, ScheduleTableStatusRefType ScheduleStatus);

#if !defined(TOPPERS_CFG1_OUT) && !defined(OMIT_INCLUDE_OS_CFG) && !defined(OMIT_INCLUDE_OS_LCFG)
#include "Os_Lcfg.h"
#endif

/*
 *  եå롼
 */
#ifdef CFG_USE_ERRORHOOK
extern void ErrorHook(StatusType Error);
#endif /* CFG_USE_ERRORHOOK */

#ifdef CFG_USE_PRETASKHOOK
extern void PreTaskHook(void);
#endif /* CFG_USE_PRETASKHOOK */

#ifdef CFG_USE_POSTTASKHOOK
extern void PostTaskHook(void);
#endif /* CFG_USE_POSTTASKHOOK */

#ifdef CFG_USE_STARTUPHOOK
extern void StartupHook(void);
#endif /* CFG_USE_STARTUPHOOK */

#ifdef CFG_USE_SHUTDOWNHOOK
extern void ShutdownHook(StatusType Error);
#endif /* CFG_USE_SHUTDOWNHOOK */

#ifdef CFG_USE_PROTECTIONHOOK
extern ProtectionReturnType ProtectionHook(StatusType FatalError);
#endif /* CFG_USE_PROTECTIONHOOK */

/*
 *  եֹ̾λѤѿ
 */
extern const char8	*fatal_file_name;   /* ե̾ */
extern sint32		fatal_line_num;     /* ֹ */

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  OSΥ顼
 */
#define E_OS_ACCESS							UINT_C(1)
#define E_OS_CALLEVEL						UINT_C(2)
#define E_OS_ID								UINT_C(3)
#define E_OS_LIMIT							UINT_C(4)
#define E_OS_NOFUNC							UINT_C(5)
#define E_OS_RESOURCE						UINT_C(6)
#define E_OS_STATE							UINT_C(7)
#define E_OS_VALUE							UINT_C(8)
#define E_OS_SERVICEID						UINT_C(9)
#define E_OS_ILLEGAL_ADDRESS				UINT_C(10)
#define E_OS_MISSINGEND						UINT_C(11)
#define E_OS_DISABLEDINT					UINT_C(12)
#define E_OS_STACKFAULT						UINT_C(13)
#define E_OS_PROTECTION_MEMORY				UINT_C(14)
#define E_OS_PROTECTION_TIME_TASK			UINT_C(15)
#define E_OS_PROTECTION_TIME_ISR			UINT_C(16)
#define E_OS_PROTECTION_ARRIVAL_TASK		UINT_C(17)
#define E_OS_PROTECTION_ARRIVAL_ISR			UINT_C(18)
#define E_OS_PROTECTION_LOCKED_RESOURCE		UINT_C(19)
#define E_OS_PROTECTION_LOCKED_OSINT		UINT_C(20)
#define E_OS_PROTECTION_LOCKED_ALLINT		UINT_C(21)
#define E_OS_PROTECTION_EXCEPTION			UINT_C(22)
#define E_OS_PROTECTION_FATAL				UINT_C(23)
#define E_OS_MODE							UINT_C(24)
#define E_OS_SHUTDOWN_FATAL					UINT_C(25)
#define E_OS_PARAM_POINTER					UINT_C(26)
#define E_OS_SYS_ASSERT_FATAL				UINT_C(27)

/* AUTOSARR4.0.3Ȥθߴθ */
#define OS_E_PARAM_POINTER					E_OS_PARAM_POINTER

#define ERRCODE_NUM							UINT_C(27) /* 顼ɿ */

/*
 *  ¾
 */
#define UINT32_INVALID		UINT_C(0xffffffff)
#define UINT8_INVALID		UINT_C(0xff)

#define SUSPENDED			((TaskStateType) 0) /* ٻ߾ */
#define RUNNING				((TaskStateType) 1) /* ¹Ծ */
#define READY				((TaskStateType) 2) /* ¹Բǽ */
#define WAITING				((TaskStateType) 3) /* Ԥ */

/*
 *  Ŭ뤿ᡤ¸Ǥκɬ
 */
#ifndef OMIT_DATA_TYPE
#define INVALID_TASK			((TaskType) UINT32_INVALID)
#define INVALID_ISR				((ISRType) UINT32_INVALID)
#endif /* OMIT_DATA_TYPE */
#define INVALID_APPMODETYPE	((AppModeType) UINT32_INVALID)

/*
 *  塼ơ֥Υơ
 */
#define SCHEDULETABLE_STOPPED					((ScheduleTableStatusType) 0x01)
#define SCHEDULETABLE_NEXT						((ScheduleTableStatusType) 0x02)
#define SCHEDULETABLE_WAITING					((ScheduleTableStatusType) 0x04)
#define SCHEDULETABLE_RUNNING					((ScheduleTableStatusType) 0x08)
#define SCHEDULETABLE_RUNNING_AND_SYNCHRONOUS	((ScheduleTableStatusType) 0x10)

/*
 *  ƥॵӥID
 */
#define OSServiceId_GetActiveApplicationMode	((OSServiceIdType) 0)
#define OSServiceId_StartOS						((OSServiceIdType) 1)
#define OSServiceId_ShutdownOS					((OSServiceIdType) 2)
#define OSServiceId_ActivateTask				((OSServiceIdType) 3)
#define OSServiceId_TerminateTask				((OSServiceIdType) 4)
#define OSServiceId_ChainTask					((OSServiceIdType) 5)
#define OSServiceId_Schedule					((OSServiceIdType) 6)
#define OSServiceId_GetTaskID					((OSServiceIdType) 7)
#define OSServiceId_GetTaskState				((OSServiceIdType) 8)
#define OSServiceId_EnableAllInterrupts			((OSServiceIdType) 9)
#define OSServiceId_DisableAllInterrupts		((OSServiceIdType) 10)
#define OSServiceId_ResumeAllInterrupts			((OSServiceIdType) 11)
#define OSServiceId_SuspendAllInterrupts		((OSServiceIdType) 12)
#define OSServiceId_ResumeOSInterrupts			((OSServiceIdType) 13)
#define OSServiceId_SuspendOSInterrupts			((OSServiceIdType) 14)
#define OSServiceId_GetISRID					((OSServiceIdType) 15)
#define OSServiceId_SetEvent					((OSServiceIdType) 16)
#define OSServiceId_ClearEvent					((OSServiceIdType) 17)
#define OSServiceId_GetEvent					((OSServiceIdType) 18)
#define OSServiceId_WaitEvent					((OSServiceIdType) 19)
#define OSServiceId_GetResource					((OSServiceIdType) 20)
#define OSServiceId_ReleaseResource				((OSServiceIdType) 21)
#define OSServiceId_IncrementCounter			((OSServiceIdType) 22)
#define OSServiceId_GetCounterValue				((OSServiceIdType) 23)
#define OSServiceId_GetElapsedValue				((OSServiceIdType) 24)
#define OSServiceId_GetAlarmBase				((OSServiceIdType) 25)
#define OSServiceId_GetAlarm					((OSServiceIdType) 26)
#define OSServiceId_SetRelAlarm					((OSServiceIdType) 27)
#define OSServiceId_SetAbsAlarm					((OSServiceIdType) 28)
#define OSServiceId_CancelAlarm					((OSServiceIdType) 29)
#define OSServiceId_StartScheduleTableRel		((OSServiceIdType) 30)
#define OSServiceId_StartScheduleTableAbs		((OSServiceIdType) 31)
#define OSServiceId_StopScheduleTable			((OSServiceIdType) 32)
#define OSServiceId_NextScheduleTable			((OSServiceIdType) 33)
#define OSServiceId_GetScheduleTableStatus		((OSServiceIdType) 34)
#define OSServiceId_TaskMissingEnd				((OSServiceIdType) 35)
#define OSServiceId_ISRMissingEnd				((OSServiceIdType) 36)
#define OSServiceId_HookMissingEnd				((OSServiceIdType) 37)

/*
 *  ݸȿ򵯤ñ̤
 */
#define FC_INVALID			UINT_C(0x00)        /* ݸȿ򵯤ñ̤Ǥʤ */
#define FC_TASK				UINT_C(0x01)        /* ݸȿ򵯤ñ̤ */
#define FC_C2ISR			UINT_C(0x02)        /* ݸȿ򵯤ñ̤C2ISR */
#define FC_SYSTEM_HOOK		UINT_C(0x03)        /* ݸȿ򵯤ñ̤ƥΥեå */

/*
 *  ƥॵӥѥ᡼Τ
 */
#ifndef TOPPERS_MACRO_ONLY

/*
 *  顼եåOFFӥIDȥѥ᡼OFFˤʤ
 */
#ifdef CFG_USE_ERRORHOOK

#ifdef CFG_USE_GETSERVICEID
extern OSServiceIdType	_errorhook_svcid;
#endif /* CFG_USE_GETSERVICEID */

#ifdef CFG_USE_PARAMETERACCESS
extern _ErrorHook_Par	errorhook_par1;
extern _ErrorHook_Par	errorhook_par2;
extern _ErrorHook_Par	errorhook_par3;
#endif /* CFG_USE_PARAMETERACCESS */

#endif /* CFG_USE_ERRORHOOK */

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  顼եåOFFӥIDȥѥ᡼OFFˤʤ
 */
#ifdef CFG_USE_ERRORHOOK

/*
 *  ޥ
 */
#ifdef CFG_USE_GETSERVICEID
#define OSErrorGetServiceId()				(_errorhook_svcid)
#endif /* CFG_USE_GETSERVICEID */

/*
 *  顼ƥॵӥID
 */
#ifdef CFG_USE_PARAMETERACCESS
#define OSError_StartOS_Mode()									(errorhook_par1.mode)
#define OSError_ActivateTask_TaskID()							(errorhook_par1.tskid)
#define OSError_ChainTask_TaskID()								(errorhook_par1.tskid)
#define OSError_GetTaskID_TaskID()								(errorhook_par1.p_tskid)
#define OSError_GetTaskState_TaskID()							(errorhook_par1.tskid)
#define OSError_GetTaskState_State()							(errorhook_par2.p_stat)
#define OSError_GetResource_ResID()								(errorhook_par1.resid)
#define OSError_ReleaseResource_ResID()							(errorhook_par1.resid)
#define OSError_SetEvent_TaskID()								(errorhook_par1.tskid)
#define OSError_SetEvent_Mask()									(errorhook_par2.mask)
#define OSError_ClearEvent_Mask()								(errorhook_par1.mask)
#define OSError_GetEvent_TaskID()								(errorhook_par1.tskid)
#define OSError_GetEvent_Event()								(errorhook_par2.p_mask)
#define OSError_WaitEvent_Mask()								(errorhook_par1.mask)
#define OSError_GetAlarmBase_AlarmID()							(errorhook_par1.almid)
#define OSError_GetAlarmBase_Info()								(errorhook_par2.p_info)
#define OSError_GetAlarm_AlarmID()								(errorhook_par1.almid)
#define OSError_GetAlarm_Tick()									(errorhook_par2.p_tick)
#define OSError_SetRelAlarm_AlarmID()							(errorhook_par1.almid)
#define OSError_SetRelAlarm_increment()							(errorhook_par2.incr)
#define OSError_SetRelAlarm_cycle()								(errorhook_par3.cycle)
#define OSError_SetAbsAlarm_AlarmID()							(errorhook_par1.almid)
#define OSError_SetAbsAlarm_start()								(errorhook_par2.start)
#define OSError_SetAbsAlarm_cycle()								(errorhook_par3.cycle)
#define OSError_CancelAlarm_AlarmID()							(errorhook_par1.almid)
#define OSError_IncrementCounter_CounterID()					(errorhook_par1.cntid)
#define OSError_GetCounterValue_CounterID()						(errorhook_par1.cntid)
#define OSError_GetCounterValue_Value()							(errorhook_par2.p_val)
#define OSError_GetElapsedValue_CounterID()						(errorhook_par1.cntid)
#define OSError_GetElapsedValue_Value()							(errorhook_par2.p_val)
#define OSError_GetElapsedValue_ElapsedValue()					(errorhook_par3.p_eval)
#define OSError_StartScheduleTableRel_ScheduleTableID()			(errorhook_par1.schtblid)
#define OSError_StartScheduleTableRel_Offset()					(errorhook_par2.offset)
#define OSError_StartScheduleTableAbs_ScheduleTableID()			(errorhook_par1.schtblid)
#define OSError_StartScheduleTableAbs_Start()					(errorhook_par2.start)
#define OSError_StopScheduleTable_ScheduleTableID()				(errorhook_par1.schtblid)
#define OSError_NextScheduleTable_ScheduleTableID_From()		(errorhook_par1.schtblid_from)
#define OSError_NextScheduleTable_ScheduleTableID_To()			(errorhook_par2.schtblid_to)
#define OSError_GetScheduleTableStatus_ScheduleTableID()		(errorhook_par1.schtblid)
#define OSError_GetScheduleTableStatus_ScheduleStatus()			(errorhook_par2.p_schtblstate)


#endif /* CFG_USE_PARAMETERACCESS */

#endif /* CFG_USE_ERRORHOOK */

/*
 *  ץƥեåطΥޥ
 */
#define PRO_IGNORE					UINT_C(0x00)
#define PRO_SHUTDOWN				UINT_C(0x01)

/*
 *  С
 */
#define OS_SW_MAJOR_VERSION				UINT_C(1)   /* ץ饤䡼С */
#define OS_SW_MINOR_VERSION				UINT_C(3)
#define OS_SW_PATCH_VERSION				UINT_C(1)

#define OS_AR_RELEASE_MAJOR_VERSION		UINT_C(4)   /* AUTOSAR꡼С */
#define OS_AR_RELEASE_MINOR_VERSION		UINT_C(0)
#define OS_AR_RELEASE_REVISION_VERSION	UINT_C(3)

#define TKERNEL_NAME	"TOPPERS/ATK2-SC1"  /* ͥ̾Ρȼ͡ */

#endif /* TOPPERS_OS_H */
