/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2011-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: kernel_fncode.h 345 2014-09-16 23:55:32Z fsi-dankei $
 */

#ifndef TOPPERS_KERNEL_FNCODE_H
#define TOPPERS_KERNEL_FNCODE_H

#define TMAX_SVCID	UINT_C(34)

#define TFN_STARTOS						UINT_C(0)
#define TFN_SHUTDOWNOS					UINT_C(1)
#define TFN_ACTIVATETASK				UINT_C(2)
#define TFN_TERMINATETASK				UINT_C(3)
#define TFN_CHAINTASK					UINT_C(4)
#define TFN_SCHEDULE					UINT_C(5)
#define TFN_GETTASKID					UINT_C(6)
#define TFN_GETTASKSTATE				UINT_C(7)
#define TFN_ENABLEALLINTERRUPTS			UINT_C(8)
#define TFN_DISABLEALLINTERRUPTS		UINT_C(9)
#define TFN_RESUMEALLINTERRUPTS			UINT_C(10)
#define TFN_SUSPENDALLINTERRUPTS		UINT_C(11)
#define TFN_RESUMEOSINTERRUPTS			UINT_C(12)
#define TFN_SUSPENDOSINTERRUPTS			UINT_C(13)
#define TFN_GETISRID					UINT_C(14)
#define TFN_GETRESOURCE					UINT_C(15)
#define TFN_RELEASERESOURCE				UINT_C(16)
#define TFN_SETEVENT					UINT_C(17)
#define TFN_CLEAREVENT					UINT_C(18)
#define TFN_GETEVENT					UINT_C(19)
#define TFN_WAITEVENT					UINT_C(20)
#define TFN_GETALARMBASE				UINT_C(21)
#define TFN_GETALARM					UINT_C(22)
#define TFN_SETRELALARM					UINT_C(23)
#define TFN_SETABSALARM					UINT_C(24)
#define TFN_CANCELALARM					UINT_C(25)
#define TFN_INCREMENTCOUNTER			UINT_C(26)
#define TFN_GETCOUNTERVALUE				UINT_C(27)
#define TFN_GETELAPSEDVALUE				UINT_C(28)
#define TFN_GETACTIVEAPPLICATIONMODE	UINT_C(29)
#define TFN_STARTSCHEDULETABLEREL		UINT_C(30)
#define TFN_STARTSCHEDULETABLEABS		UINT_C(31)
#define TFN_STOPSCHEDULETABLE			UINT_C(32)
#define TFN_NEXTSCHEDULETABLE			UINT_C(33)
#define TFN_GETSCHEDULETABLESTATUS		UINT_C(34)

#endif /* TOPPERS_KERNEL_FNCODE_H */
