/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: interrupt.h 345 2014-09-16 23:55:32Z fsi-dankei $
 */

/*
 *		ߴǽ
 */

#ifndef TOPPERS_INTERRUPT_H
#define TOPPERS_INTERRUPT_H

#include "resource.h"

/*
 *  ͥͤɽ
 */
#define TPRI_MINISR		(-1)                /* ͥ */

/*
 *  ISRCBISRIDФΥޥ
 */
#define ISR2ID(p_isrcb)	((ISRType) ((p_isrcb) - isrcb_table))

#ifndef OMIT_INITIALIZE_INTERRUPT

/*
 *  ׵饤֥å
 */
typedef struct interrupt_request_initialization_block {
	InterruptNumberType	intno;          /* ֹ */
	AttributeType		intatr;         /* ° */
	PriorityType		intpri;         /* ͥ */
#if defined(TOPPERS_CFG1_OUT) || defined(CFG_USE_STACKMONITORING)
	MemorySizeType remain_stksz;        /* ḁ̊åѥå */
#endif /* defined(TOPPERS_CFG1_OUT) && defined(CFG_USE_STACKMONITORING) */
} INTINIB;

/*
 *  ׵饤οOs_Lcfg.c
 */
extern const InterruptNumberType	tnum_intno;

/*
 *  ׵饤֥åΥꥢOs_Lcfg.c
 */
extern const INTINIB				intinib_table[];

/*
 *  ISRCBͥ٤Фޥ
 */
#define GET_INTPRI(p_isrcb)	((p_isrcb)->p_intinib->intpri)

#endif /* OMIT_INITIALIZE_INTERRUPT */

/*
 *  C2ISRݻѿOs_Lcfg.c
 */
extern const ISRType				tnum_isr2; /* C2ISRο */

typedef struct isr_control_block {
	const INTINIB	*p_intinib;
	RESCB			*p_lastrescb;   /* Ǹ˳꥽֥åؤΥݥ */
} ISRCB;

/*
 *  C2ISRδ֥åΥꥢOs_Lcfg.c
 */
extern ISRCB						isrcb_table[];

/*
 *  ¹C2ISR
 *
 *  C2ISR¹ԤƤʤϡNULL ˤ
 */
extern ISRCB						*p_runisr;

/*
 *  SuspendAllInterrupts ΥͥȲ
 */
extern uint8						sus_all_cnt;
extern uint8						sus_all_cnt_ctx;
/*
 *  SuspendOSInterrupts ΥͥȲ
 */
extern uint8						sus_os_cnt;
extern uint8						sus_os_cnt_ctx;

/*
 *  ߴǽν
 */
extern void interrupt_initialize(void);

/*
 *  ߶ػߤζ
 */

extern void release_interrupts(OSServiceIdType serviceId);

/*
 *  C2ISRλΥåؿ
 */
extern void exit_isr2(void);

#endif /* TOPPERS_INTERRUPT_H */
